// ************************************************************************
//                /////            -/      /|    /                  |\
//   |\          /                 /      / |   /|             |\   |
//   |\          \\\\             /      /  |  / |             |\ /\|
// /\|               \  /\ /\  * /      /   | /  |  * |/     /\|  \/
// \/            ///// / / -/ / /      /    |/   | /  /|     \/
//
// Snail Mix Digital Audio Library, CopyRight(C) 1998 Timothy Curtis Harper
// ************************************************************************
// THIS LIBRARY IS PROVIDED AS AN "AS IS" BASIS.  THE AUTHOR IS NOT
// RESPONSIBLE FOR ANY INCONSEQUENTIAL DAMAGE THAT MAY OCCURE BY COMPILING
// THIS SOURCE.  READ "README.TXT" FOR MORE DETAILS
// ************************************************************************
//            See updates, news, and download new version at
//                 http://members.tripod.com/~SaltySnail
/////////////////////////////////////////////////////////////////////////////

#include "mixer.h"
#include <stdio.h>
void strscan(char *strdata);

void byebye() // L8r
{
KillMixer();
exit();
}

void main()
{
char filename[40];
unsigned char y;

// Initialize the Mixer
switch (InitMixer(0,0,0,1,0))  // Initialize mixer, If you set the address
                       // (the 1st number) to zero it gets the settings from
                       // the SB environment string
  {
  case -1 : printf("SB environment string not set, please do so in with this DATA\n");
            printf("SET BLASTER=Axxx Ix Dx\n");
            printf("Where A is the address, I is the IRQ, and D is the DMA channel\n");
            printf("  And of course, replace the x's with the correct value for each\n");
            exit();
            break;
  case 0 : printf("SB card not found at given address (Could be in use or BLASTER ENV string\nisn't right.\n");
           exit();
           break;
  case 1 : printf("SB card initialized at Address %x IRQ %d DMA %d\n", SBIOAddr, SBIRQ, SBDMA);
           printf("DSP version %x.%x\n",DSPVer>>8,DSPVer&(0xff));

           printf("Stereo is ");
           if (SBStereo) printf("on\n"); else printf("off\n");
           printf("16Bit is");
           if (SB16Bit) printf("on\n"); else printf("off\n");
           break;
  }

// Pick a song
printf("Enter the song to load ->\n");
strscan(filename);

// Load the song
switch (LoadS3M(filename))
  {
  case -1 : printf("File Not Found, Exiting...\n"); byebye();break;
  case 0 : printf("File is not S3M, Exiting...\n"); byebye();break;
  case 1 : printf("Song Loaded\n");break;
  }
printf("Press a key...\n");
getch();
clrscr();

PlaySong();
printf("Playing %s...\n",song.name);
y=wherey();
printf("%d\n",y);

while (!kbhit()) // Your program does something here
  {
  gotoxy(1,y);
  printf("Order %d Pattern %d Row %d Tempo %d Speed %d GVol %d   \n", ordnum, patnum, rownum, song.Tempo, song.Speed, song.GVolume);
  { if (!HighPriority) PollMixing();}
  }
DestroyS3M();
KillMixer();
}

void strscan(char *strdata)
{
unsigned char x, y, pos=0;
char c;
y=wherey();
x=wherex();
while (!kbhit()) { if (!HighPriority) PollMixing();}
c=getch();
while (c!=13 && c!=27)
  {
  if (c==8) // backspace
    {
    if (pos)
      {
      pos--;
      putch(c);
      putch(' ');
      putch(c);
      }
    }
   else
    {
    strdata[pos++]=c;
    putch(c);
    }
  while (!kbhit()) { if (!HighPriority) PollMixing();}
  c=getch();
  }
strdata[pos++]=0; // Null terminator
if (c==27) strdata=NULL; //return no string
}

