#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <crt0.h>
#include <sys/nearptr.h>
#include <dpmi.h>
#include "mixer.h" // This header has the structures, and most of the defines & extern def's
#include "fixed.h"

unsigned int index;

void GenScaleTab(unsigned char SMPIndex)
{
float scale, factor=0.0594631;
unsigned char ST_Index;
scale=DigINS[SMPIndex].C4Speed;
scale=scale/SamplingRate;

for (ST_Index=0;ST_Index<=11;ST_Index++)
  {
  DigINS[SMPIndex].ScaleTable[ST_Index]=AssignFixed(scale);
  scale+=scale*factor;
  }
}

int LoadVoc(char *filename)
{
FILE *infile;
unsigned int i;
unsigned char SMPIndex;
unsigned char parapointer;
unsigned char done=0;
unsigned int BlockLength;
unsigned int BlockToRead;

SMPIndex=0;
if ( (infile=fopen(filename,"rb"))==NULL) { song.loaded=0;return(-1);}
for (i=100;i<=DigInsNum;i++)
  if (DigINS[i].SMPLoaded==0)     //Nothing loaded in this slot?
    {
    SMPIndex=i;                  //Good, load the ins here
    i=DigInsNum+1;                       //Bail
    }
if (!SMPIndex)
  return(-2); // out of samplebank space

fseek(infile,0x14,SEEK_SET); // Skip Signature
parapointer=fgetw(infile);  // 16 bit int that points to the good stuff
fseek(infile,parapointer,SEEK_SET);
BlockLength=0;
do
switch (getc(infile))
  {
  case 0 : //Terminator
           done=1;
           break;
  case 1 : // read block type 1
           BlockLength+=getc(infile);
           BlockLength+=getc(infile)<<8;
           BlockLength+=getc(infile)<<16; // the length is 3 bytes long
           BlockLength-=2;
           printf("%d\n",BlockLength);
           BlockToRead=BlockLength;
           DigINS[SMPIndex].C4Speed=-1000000 / (getc(infile)-256); //SamplingRate=-1000000 / (TimeConstant-256);       //Make Sure Sampling rate is the same as what the speakers are doing
           printf("%d\n",DigINS[SMPIndex].C4Speed);
           DigINS[SMPIndex].SMPLength=BlockLength;
           DigINS[SMPIndex].LoopStart=0;
           DigINS[SMPIndex].DefaultVol=63;
           DigINS[SMPIndex].LoopMode=0;

           DigINS[SMPIndex].LoopEnd=BlockLength;
           DigINS[SMPIndex].SMPLoaded=1;

           getc(infile);  // Skip Packing
           if ((DigINS[SMPIndex].SMPData=(char *)malloc(DigINS[SMPIndex].SMPLength))==NULL) return(0);

           for (i=0;i<BlockToRead;i++)
             {
             DigINS[SMPIndex].SMPData[i]=getc(infile);
            // printf(" %d",DigINS[SMPIndex].SMPData[i]);
             }
//           printf( "\n");

           break;
  case 6 : // loop begins
           break;
  case 7 : // loopends
           break;
  case 9 : BlockLength+=getc(infile);
           BlockLength+=getc(infile)<<8;
           BlockLength+=getc(infile)<<16; // the length is 3 bytes long

           BlockLength-=13;
           BlockToRead=BlockLength;
           printf("%d=%d\n",BlockToRead, BlockLength);
           DigINS[SMPIndex].C4Speed=getw(infile); // C4 Speed, sampling rate to play at C4
           getc(infile);                  // BitsPerSample
           getc(infile);                  // 1=Mono, 2=Stereo

           getc(infile);getc(infile);getc(infile);getc(infile);getc(infile);getc(infile); // Skip 6 bytes
           DigINS[SMPIndex].SMPLength=BlockLength;
           DigINS[SMPIndex].LoopStart=0;
           DigINS[SMPIndex].DefaultVol=63;
           DigINS[SMPIndex].LoopMode=0;

           DigINS[SMPIndex].LoopEnd=BlockLength;
           DigINS[SMPIndex].SMPLoaded=1;

           if ((DigINS[SMPIndex].SMPData=(char *)malloc(DigINS[SMPIndex].SMPLength))==NULL) return(0);

           for (i=0;i<=BlockToRead;i++)
             {
             DigINS[SMPIndex].SMPData[i]=getc(infile);
             }
           break;
  default : // just read the rest in as raw data
           done=1;
           break;
  }
while (!(feof(infile)) && (!done));
fclose(infile);
GenScaleTab(SMPIndex);
return(SMPIndex);
}

int LoadWav(char *filename) // Do not try this function yet
{
FILE *infile;
unsigned int i;
unsigned char SMPIndex;
unsigned char parapointer;
unsigned int BlockLength;
unsigned int BlockToRead;

if ( (infile=fopen(filename,"rb"))==NULL) { song.loaded=0;return(-1);}
for (i=100;i<=DigInsNum;i++)
  if (DigINS[i].SMPLoaded==0)     //Nothing loaded in this slot?
    {
    SMPIndex=i;                  //Good, load the ins here
    i=DigInsNum+1;                       //Bail
    }
fseek(infile,0x14,SEEK_SET); // Skip Signature
parapointer=fgetw(infile);  // 16 bit int that points to the good stuff
fseek(infile,parapointer,SEEK_SET);
BlockLength=0;

fclose(infile);
GenScaleTab(SMPIndex);
return(SMPIndex);
}

// ------------------------LOAD S3M-----------------------------------------
// - Purpose : Loads an S3M file                                           -
// - Usage   : LoadS3m("RAIN.S3M");                                        -
// -                                                                       -
// -                                                                       -
// -                                                                       -
// ------------------------LOAD S3M-----------------------------------------
char LoadS3MSample(FILE *infile, unsigned int parapointer, char i)
{
unsigned int Index;
unsigned char SMPIndex, ST_Index;

char index, leave=0, oct=4;

unsigned int fscale;

if (i<0)                           //If i < 0 then find an empty slot for instrument
  {
  for (i=99;i>=0;i--)
    if (DigINS[i].SMPLoaded==0)     //Nothing loaded in this slot?
      {
      SMPIndex=i;                  //Good, load the ins here
      i=100;                       //Bail
      }
  }
 else
  {
  SMPIndex=i;
  }

fseek(infile,parapointer*0x10,SEEK_SET);
if (fgetc(infile)!=1 ) // If this byte is not 1 then skip it (either nothing here or adlib ins)
  {
  return(-1); // Return unsuccessful
  }

fseek(infile,parapointer*0x10+0x0e,SEEK_SET);

DigINS[SMPIndex].MemSeg=fgetw(infile);
DigINS[SMPIndex].SMPLoaded=1;

DigINS[SMPIndex].SMPLength=fgetw(infile);
DigINS[SMPIndex].SMPLength+=fgetw(infile)<<16;     // Skip HI:Length section of file (Max SMP's=65535 for this prog}

DigINS[SMPIndex].LoopStart=fgetw(infile);
DigINS[SMPIndex].LoopStart+=fgetw(infile)<<16;  // Skip HI:LoopStart

DigINS[SMPIndex].LoopEnd=fgetw(infile);
DigINS[SMPIndex].LoopEnd+=fgetw(infile)<<16;    // Skip Hi:LoopEnds

if ((DigINS[SMPIndex].DefaultVol=fgetc(infile)) > 63) DigINS[SMPIndex].DefaultVol=63;
fgetc(infile);                      // This Info Unneeded
fgetc(infile);                      // We don't support ADPCM packing! maybe sometime in ver 3.0??? or never???  I like the never idea.
if ((DigINS[SMPIndex].LoopMode=fgetc(infile))!=1) DigINS[SMPIndex].LoopMode=0;

if (DigINS[SMPIndex].LoopMode!=1) { DigINS[SMPIndex].LoopEnd=DigINS[SMPIndex].SMPLength; }  // Sample End is detected by loopend
DigINS[SMPIndex].C4Speed=fgetw(infile);

#ifdef DoSMPNames
fseek(infile,(parapointer*0x10)+0x30,SEEK_SET);
for (Index=0;Index<28;Index++)
  {
  DigINS[SMPIndex].SMPName[Index]=fgetc(infile);
  }
#endif

if ((DigINS[SMPIndex].SMPData=(char *)malloc(DigINS[SMPIndex].SMPLength))==NULL) return(OutOfMem);

fseek(infile,DigINS[SMPIndex].MemSeg*0x10,SEEK_SET);

for (Index=0;Index<DigINS[SMPIndex].SMPLength;Index++)
  {
  DigINS[SMPIndex].SMPData[Index]=fgetc(infile);
  }

GenScaleTab(SMPIndex);
return(SMPIndex);
}
int LoadS3MPattern(FILE *infile,unsigned char patnum, unsigned int parapointer)
{
unsigned int contents=1, rows=0, patlen=0;

fseek(infile,parapointer*0x10,SEEK_SET);

patlen=getc(infile);
patlen+=getc(infile) << 8;

if ((song.patterndata[patnum]=(char *)malloc(patlen))==NULL)
  {
  return(OutOfMem);
  }
else
  {
  song.patternloaded[patnum]=1;
  }

for (index=0;index<patlen;index++)
  {
  song.patterndata[patnum][index]=getc(infile);
  }

}

char LoadS3M(char *filename)
{
FILE *infile;
unsigned char loop;
unsigned char tc;
unsigned char chanstereo;
if ( (infile=fopen(filename,"rb"))==NULL) { song.loaded=0;return(-1);}
for (loop=0;loop<28;loop++)
  {
  song.name[loop]=getc(infile);
  }

getc(infile);

song.type  =getc(infile);         // Type

getc(infile);
getc(infile);   // The 2 x's I have no clue what they there 4

song.ordnum=fgetw(infile);
song.insnum=fgetw(infile);
song.patnum=fgetw(infile);
song.flags =fgetw(infile);
song.cwtv  =fgetw(infile);
song.ffv   =fgetw(infile);

if (getc(infile)=='S')
 if (getc(infile)=='C')
  if (getc(infile)=='R');
   if (getc(infile)=='M');
    goto Loadit;  // If the SCRM header matches skip the return an error

fclose(infile);
return(0);

Loadit:
song.loaded=1;
song.InitGVolume=fgetc(infile);
song.GVolume=song.InitGVolume;
song.InitSpeed=fgetc(infile);
song.InitTempo=fgetc(infile);
song.MVolume=fgetc(infile);
printf("%d\n",song.MVolume);
SetMasterVol(song.MVolume);
fseek(infile,0x3E,SEEK_SET);
getc(infile);getc(infile); // Skip 2 bytes, I dunno why they are there, but its been throwing me off

printf("%d\n",song.MVolume);
if (song.MVolume&128) // if bit 8 is set, the song is stereo else mono
  {
  chanstereo=1; // song is stereo
  song.MVolume-=128; // Take 128 bit off
  }
 else
  chanstereo=0; // song is mono

for (loop=0;loop<32;loop++)
  {
  tc=getc(infile);
  printf("%d\n", tc);
  if (tc!=255) // is channel enabled?  Comment this out if it doesn't work right
//  This doesn't work so i did it for you
    {
    if (chanstereo)
      {
      if (tc<=7) // Good, left?
       MixChannel[loop].PanPos=0; // Set it all the way left
      else
       MixChannel[loop].PanPos=128; // All the was right
      }
     else
      {
      MixChannel[loop].PanPos=64; // Song is mono, all channels center
      }
    }
  }
for (loop=0;loop<song.ordnum;loop++)
  {
  song.ordtable[loop]=getc(infile);
  }

for (loop=0;loop<song.insnum;loop++)
  {
  song.insptr[loop]=fgetw(infile);
  }

for (loop=0;loop<song.patnum;loop++)
  {
  song.patternptr[loop]=fgetw(infile);
  }

SetTempo(song.InitSpeed,song.InitTempo);
patnum=0;
ordnum=0;
rownum=0;

for (loop=0;loop<song.patnum;loop++)
  {
  LoadS3MPattern(infile,loop,song.patternptr[loop]);
  }

for (loop=0;loop<song.insnum;loop++)
  {
  LoadS3MSample(infile,song.insptr[loop],loop);
  }

fclose(infile);
SetGVolume(song.GVolume);
return(1);
}

void DestroyS3M() // destroy loaded s3m song
{
unsigned char Chan;
if (!song.loaded) return;

StopSong();
for (index=0;index<=100;index++)
  {
  if (DigINS[index].SMPLoaded==SongSample)
    {
    for (Chan=0;Chan<=MaxChannels;Chan++)
      if (MixChannel[Chan].SMPIndex==index) // If a channel is playing a sample that we are destroying, stop it
        MixChannel[Chan].Playing=0;

    DigINS[index].SMPLoaded=0;
    free(DigINS[index].SMPData);  // Kill Sample Data
    }
  if (song.patternloaded[index])
    {
    song.patternloaded[index]=0;
    free(song.patterndata[index]);
    }
  }

song.loaded=0;
}