// ************************************************************************
//                /////            -/      /|    /                  |\
//   |\          /                 /      / |   /|             |\   |
//   |\          \\\\             /      /  |  / |             |\ /\|
// /\|               \  /\ /\  * /      /   | /  |  * |/     /\|  \/
// \/            ///// / / -/ / /      /    |/   | /  /|     \/
//
// Snail Mix Digital Audio Library, CopyRight(C) 1998 Timothy Curtis Harper
// ************************************************************************
// THIS LIBRARY IS PROVIDED AS AN "AS IS" BASIS.  THE AUTHOR IS NOT
// RESPONSIBLE FOR ANY INCONSEQUENTIAL DAMAGE THAT MAY OCCURE BY COMPILING
// THIS SOURCE.  READ "README.TXT" FOR MORE DETAILS
// ************************************************************************
//            See updates, news, and download new version at
//                 http://members.tripod.com/~SaltySnail
/////////////////////////////////////////////////////////////////////////////


// Snail Mix, S3M player + Sound FX
// By Tim Harper
// Compiled under DJGPP, gcc version 2.7.2.1
// You need to link the following to this code
// fixed.c, loadfile.c, sb.c

// If you have ANY problems compiling this I WANT TOO KNOW!!!!
// I hate getting things that don't work.
// Email @ timharper@hotmail.com

#define DEBUG

#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <crt0.h>
#include <sys/nearptr.h>
#include <dpmi.h>
#include "mixer.h" // This header has the structures, and most of the defines & extern def's
#include "fixed.h"

MixChan MixChannel[MaxChannels];
MixChan *MC; // Current Channel
TDigSMP DigINS[DigInsNum+1];

struct S3MSong song;

unsigned int SMPSPerRow=1024;

unsigned char VolumeTable[64][256];  // Yes, all of my tables are UNSIGNED!!!!!!!
unsigned char ClipTable[512];        // It is much faster to add UNSIGNED variables then SIGNED.

//---------------------------------------------Interrupt Vars
char CurBlockNum=0;

//---------------------------------------------Test Vars
unsigned int Calls=0;

char Waittick(char ticks)
{
char ct=0,i;
for (i=0;i<=ticks;i++)
  {
  ct=time(0);
  while (time(0)==ct) {;}
  }
}

unsigned char UDM_ChannelNum;
unsigned int UDM_Index, MixBufPos, tmp, UDM_SMPPlayAmount, UDM_Need2Mix, TMixBufPos;
unsigned char *InsPtr;
unsigned int Mix_Index,Mix_Start,Mix_End;
#ifdef DEBUG
unsigned char MixerCalls=0;
unsigned int LoopSMPS,pollflag, flag;
unsigned char CurVolumeL=0, CurVolumeR=0, donothing=0;
unsigned int Speed=1;
unsigned int playrowcalls=0;
#endif

// For Patterns
unsigned int patindex=0;
unsigned int LoopPeriod=0;
unsigned char contents=1, patnum=0, ordnum=0, rownum=0, playing=0, looping=1;
unsigned char Index;
unsigned char oct,noteindex;
unsigned char channel;
unsigned char PNote, PIns, PVolume, PCmd, PVal;
unsigned int PitchAdjuster=(22222*22222)/DefaultSamplingRate; // I use this number for pitch bends
// For Player
unsigned int SMPSToMix, stpor=100;
unsigned MaxVolume=63;

char HighPriority=1;  // Change this to zero to poll the mixer
unsigned char SinTable[] =
{
   0,25,50,74,98,120,142,162,180,197,212,225,236,
   244,250,254,255,254,250,244,236,225,212,197,180,
   162,142,120,98,74,50,25
};


// -------------------------------------------------------------------------
// -----------------------------Song Player---------------------------------
// -------------------------------------------------------------------------

void SetTempo(unsigned char Speed, unsigned char Tempo)
{
disable();
if (Tempo==0) Tempo=120;
SMPSPerRow=(5*SamplingRate)/(2*Tempo);
//1024    =(Speed*60*22222)/(24*Tempo);
song.Speed=Speed;
song.RowSpeed=Speed-1;
song.Tempo=Tempo;
enable();
}

unsigned char GVolume(unsigned char invol)
{
invol=((invol*song.GVolume)/MaxGVolume);
if (invol>MaxVolume)
 return(MaxVolume);
else
 return(invol);
}

void SetVol(unsigned char channel, unsigned char PVolume)
{
MixChannel[channel].RealVol=PVolume;  // Tuck away Value for future reference
MixChannel[channel].Vol=GVolume(PVolume);
if (SBStereo);
  {
  if (MixChannel[channel].PanPos!=0)
    MixChannel[channel].LVol=GVolume( (PVolume*(128-MixChannel[channel].PanPos))/(128) );
   else
    MixChannel[channel].LVol=GVolume(PVolume);

  if (MixChannel[channel].PanPos!=128)
    MixChannel[channel].RVol=GVolume( (PVolume*MixChannel[channel].PanPos)/(128) );
   else
    MixChannel[channel].RVol=GVolume(PVolume);
  }
}

void SetGVolume(unsigned char what)
{
if (what>0x39) what=0x039;
song.GVolume=what;
MaxVolume=(63*what)/MaxGVolume;
}

unsigned int CalcSpeed(unsigned char NoteNum, unsigned char SMPNum)
{
unsigned int rv=0;
      oct=      NoteNum>>4;
      noteindex=NoteNum & 0x0f;

      if (oct<MidOctive)
        {
        rv=DigINS[SMPNum].ScaleTable[noteindex] >> (MidOctive-oct);
        } else
      if (oct>MidOctive)
        {
        rv=DigINS[SMPNum].ScaleTable[noteindex] << (oct-MidOctive);
        } else
          rv=DigINS[SMPNum].ScaleTable[noteindex];

return(rv);
}

void InitNote(unsigned char SMPNum, unsigned char Channel, unsigned char NoteNum)
{

/*if (!DigINS[SMPNum].SMPLoaded)
  { return(-1); }*/

if (DigINS[SMPNum].SMPLoaded)
      {
      MixChannel[Channel].Playing=1;
      MixChannel[Channel].Pos=0;
      MixChannel[Channel].LoopMode=DigINS[SMPNum].LoopMode;
      MixChannel[Channel].LoopStart=DigINS[SMPNum].LoopStart;
      MixChannel[Channel].LoopEnd=DigINS[SMPNum].LoopEnd;
      MixChannel[Channel].SMPLength=DigINS[SMPNum].SMPLength;

      MixChannel[Channel].Speed=CalcSpeed(NoteNum,SMPNum);

      MixChannel[Channel].SMPIndex=SMPNum;
      }
}

// PlayRow()
// This function uncompresses a row of an S3M pattern and plays it
void ChangeOrder(unsigned char to_ordnum)
{
//disable();
rownum=0;
ordnum=to_ordnum;
co_again:
switch (song.ordtable[ordnum])
  {
  case 255 : { // If we tried to change to pat 255 that means it is end of pattern list
             ordnum=0;
             patnum=song.ordtable[ordnum];
             } break;
  case 254 : {
             ordnum++;
             goto co_again;
             } break;

  default : patnum=song.ordtable[ordnum];
  }
patindex=0;
//enable();
}

void SeekRow(unsigned char rn)
{
patindex=0;
if (!rownum) return;

for (rownum=0;rownum<rn;rownum++)
  {
  contents=1;
  while (contents!=0)
    {
    contents=song.patterndata[patnum][patindex++];

    if (contents!=0)
      {
      channel=contents & ChannelBits;

      if (contents&GetNoteIns) patindex+=2;
      if (contents&GetVolume) patindex+=1;
      if (contents&GetCommandInfo) patindex+=2;
      } // End if Contents!0
    } // End While
  } // End for
}

unsigned char Playnote, ChangeVolume, BreakPattern, InsChange;

void PlayRow()
{
#ifdef DEBUG
playrowcalls++;
#endif
BreakPattern=0;
  for (channel=0;channel<MaxChannels;channel++)
    {
    MixChannel[channel].Effect=0;
    }
  contents=1;
  while (contents!=0)
    {

    contents=song.patterndata[patnum][patindex++];

    if (contents!=0)
      {
      channel=contents & ChannelBits;

      if (contents&GetNoteIns)
        {
        PNote=song.patterndata[patnum][patindex++];
        PIns=song.patterndata[patnum][patindex++]-1;
        if (PNote!=255)  // 255 means no note there
          MixChannel[channel].note=PNote;

        if (PIns<=99) // PIns=255 means use the previous instrument, plus if the value is out of the 99 range it could cause it to crash
          {
          MixChannel[channel].ins=PIns;
          InsChange=1;
          }
         else
          {
          InsChange=0;
          }

        MixChannel[channel].InitFX=0xff; //00011111b

        Playnote=1;
        }
       else
        Playnote=0;  // No Ins/note?  Don't play a note

      if (contents&GetVolume)
        {
        PVolume=song.patterndata[patnum][patindex++];
        ChangeVolume=1;  // Make sure this is registered;
//        printf("Chan %d Playing at %d volume \n",channel,PVolume);
        }
       else
        {
        ChangeVolume=0;
        PVolume=DigINS[PIns].DefaultVol;
        }

      if (contents&GetCommandInfo)
        {

        switch (song.patterndata[patnum][patindex++])
          {
          case EfBreakPattern : if (!BreakPattern) // If two rows break have a break command at the same time
                                  {                //, then it will cause it to skip two rows.  Advoid this.
                                  BreakPattern=1;
                                  MixChannel[channel].Effect=EfBreakPattern;
                                  MixChannel[channel].Value=song.patterndata[patnum][patindex++];
                                  rownum=0;
                                  }
                                break;
          case EfGlisVolSlide : MixChannel[channel].Effect=EfGlisVolSlide; // Last byte was the effect number
                                if (song.patterndata[patnum][patindex]!=0)  // If the effect isn't zero set the new value.
                                  {
                                  MixChannel[channel].Value=song.patterndata[patnum][patindex];
                                  }
                                patindex++;  // Goto next byte// Goto next line, but effect will still be GlissVolSlide
                                goto CalcPortto;
                                break;
          case EfGlissando : MixChannel[channel].Effect=EfGlissando; // Last byte was the effect number
                             if (song.patterndata[patnum][patindex]!=0)  // If the effect isn't zero set the new value.
                               {
                               MixChannel[channel].GlissValue=song.patterndata[patnum][patindex];
                               }
                             patindex++;  // Goto next byte

//                             MixChannel[channel].GlissValue=MixChannel[channel].Value;
                             CalcPortto:

                             if (Playnote)
                               {
                               MixChannel[channel].InitFX&=0xf7; //11110111b turn off bit 4

                               MixChannel[channel].Playing=1; //Turn it on if a note was initialized

                               if (ChangeVolume || InsChange)
                                 {
                                 SetVol(channel,PVolume);
                                 }

                               MixChannel[channel].FXParam1=CalcSpeed(MixChannel[channel].note,MixChannel[channel].ins);
                               }
                              else // Else, if the gliss function isn't on a note
                               {
                               if (MixChannel[channel].InitFX&GlissandoBit) // If this bit is true, it means a glissando hasn't been initialized yet
                                 {
                                 MixChannel[channel].Effect=0; // don't do anything, because it should already be on the pitch
                                 }
                               } // End if playnote

                             if (MixChannel[channel].Speed>MixChannel[channel].FXParam1)  // If the gliss to speed is higher than the current speed,
                               MixChannel[channel].FXParam2=1; // Set this flag telling to go down
                              else                             // Otherwise...
                               MixChannel[channel].FXParam2=0; // Set it so we go Up

                             Playnote=0;
                             break;

          case EfAppregio : if ( (MixChannel[channel].note<=0xa0) && (MixChannel[channel].note) ) // Lets not appregio anything above 10 octives or note zero (Plus a pattern break is 255 and we wouldn't want a situation like that!
                              {
                              MixChannel[channel].InitFX&=(0xff ^ AppregioBit); //11111111b xor 00010000b turn off bit 5
                              MixChannel[channel].Effect=EfAppregio; // Last byte was the effect number
                              if (song.patterndata[patnum][patindex]!=0)  // If the effect isn't zero set the new value.
                                {
                                MixChannel[channel].Value=song.patterndata[patnum][patindex];
                                }
                              patindex++;  // Goto next byte
                              MixChannel[channel].CenterSpeed=CalcSpeed(MixChannel[channel].note,MixChannel[channel].ins);
                              MixChannel[channel].FXParam2=0;  // We'll use this byte for the count
                              } break;

          case EfSpecial : MixChannel[channel].Effect=song.patterndata[patnum][patindex-1];
                           MixChannel[channel].Value=song.patterndata[patnum][patindex++];
                           switch (MixChannel[channel].Value>>4)
                             {
                             case 0x8 : MixChannel[channel].Effect=EfSetPan;
                                        MixChannel[channel].Value<<=3; //Value*=8;
                                        break;
                             case 0xc : MixChannel[channel].Effect=EfNoteCut;
                                        MixChannel[channel].Value=MixChannel[channel].Value&0x0f;
                                        break;
                             case 0xd : if (Playnote) // If no note is played don't retrig it
                                          {
                                          MixChannel[channel].Effect=EfNoteDelay;
                                          MixChannel[channel].Value=MixChannel[channel].Value&0x0f;
                                          MixChannel[channel].FXParam3=PVolume;
                                          Playnote=0;
                                          ChangeVolume=0;
                                          }
                                        break;
                        }
                      break;
          case EfFineVibrato :
          case EfVibrato : {
                           MixChannel[channel].Effect=song.patterndata[patnum][patindex-1]; // Last byte was the effect number
                           if (song.patterndata[patnum][patindex]!=0)  // If the effect value isn't zero set the new value.
                             {
                             MixChannel[channel].Value=song.patterndata[patnum][patindex];
                             if ((MixChannel[channel].Value>>4)!=0) // if hi bit changes, whole thing changes
                               {
                               MixChannel[channel].VibValue=MixChannel[channel].Value;
                               }
                              else  // Else lo bits not zero, so just lo changes
                               {
                               MixChannel[channel].VibValue&=0xf0; // lose lo bits
                               MixChannel[channel].VibValue+=MixChannel[channel].Value; // Add the lo bits
                               }
                             }
                           patindex++;  // Goto next byte;
                           } break;
          case EfTremor : { // This doesn't work right.
                     MixChannel[channel].Effect=EfTremor;
                     if (song.patterndata[patnum][patindex]!=0)  // If the effect isn't zero set the new value.
                       {
                       MixChannel[channel].Value=song.patterndata[patnum][patindex];
                       }
                     patindex++;  // Goto next byte;
                     if (Playnote) // If there is a note, initialize the tremor
                       {
                       MixChannel[channel].FXParam2=(MixChannel[channel].Value>>4);  // Get the hi byte for on time then * by 2
                       MixChannel[channel].FXParam3=1;
                       }

                     MixChannel[channel].FXParam1=PVolume;   // This is the volume of the note

                     } break;
          case EfRetrig : {
                          MixChannel[channel].Effect=EfRetrig;
                          if (song.patterndata[patnum][patindex]!=0)  // If the effect isn't zero set the new value.
                            {
                            MixChannel[channel].Value=song.patterndata[patnum][patindex];
                            }
                          if (MixChannel[channel].InitFX & RetrigBit)
                            {
                            MixChannel[channel].InitFX&=0xFB; // 11111011b turn off Init Retrig Bit
                            MixChannel[channel].FXParam3=MixChannel[channel].Value & 0xf; // Lo bits are waitbits
                            }
                          }

          default : MixChannel[channel].Effect=song.patterndata[patnum][patindex-1]; // Last byte was the effect number
                    if (song.patterndata[patnum][patindex]!=0)  // If the effect isn't zero set the new value.
                      {
                      MixChannel[channel].Value=song.patterndata[patnum][patindex];
                      }
                    patindex++;  // Goto next byte;
                    break;
          }//End Case for effects
        } //End if for GetCommand Info

      if (MixChannel[channel].InitFX!=0xff) // Sumthing changed
        {
        if (!(MixChannel[channel].InitFX & VibratoBit)) // 00000001b
        // If vibrato init flag is zero, it means there was one initialized this note
          {
          if ( (MixChannel[channel].Effect!=EfVibrato)     &&
               (MixChannel[channel].Effect!=EfVibVolSlide) &&
               (MixChannel[channel].Effect!=EfFineVibrato) ) // If vibrato command stops, restore original pitch.
            {
            MixChannel[channel].InitFX|=VibratoBit;  // Quit setting back to center speed
            MixChannel[channel].Speed=MixChannel[channel].CenterSpeed; // This couldn't have worked out better! :-)
            }
          }
        if (! (MixChannel[channel].InitFX & AppregioBit))
          {
          if ( MixChannel[channel].Effect!=EfAppregio )
            {
            MixChannel[channel].InitFX|=AppregioBit;  // Quit setting back the note
            MixChannel[channel].Speed=CalcSpeed(MixChannel[channel].note,MixChannel[channel].ins);
            }
          }
        }

      if (Playnote || ChangeVolume)
        {
        if (Playnote)
          switch (MixChannel[channel].note)
            {
            case 254 : MixChannel[channel].Playing=0;break;
            case 255 : break;
            default  : InitNote(MixChannel[channel].ins,channel,MixChannel[channel].note);break;
            }
        if (ChangeVolume || InsChange)
          {
          SetVol(channel,PVolume);
          }
        }

      } // End if Contents!0
    } // End While


if (++rownum>63)
  {
  if (!BreakPattern) ChangeOrder(++ordnum);//Add 1 to ordnum
  }

}

// Effects
unsigned char index, hi, lo;
int FXtmp;
void S3MVolSlide(unsigned char index, unsigned char val)
{
hi=val >> 4;
lo=val & 0x0f;
FXtmp=MixChannel[index].RealVol;
if (hi==0) if (song.SpeedCount) FXtmp=MixChannel[index].RealVol-lo;
if (lo==0) if (song.SpeedCount) FXtmp=MixChannel[index].RealVol+hi;
if (hi==0xf) if (!song.SpeedCount) FXtmp=MixChannel[index].RealVol-lo;
if (lo==0xf) if (!song.SpeedCount) FXtmp=MixChannel[index].RealVol+hi;
if (FXtmp!=MixChannel[index].RealVol)
  {
  if (FXtmp<0) FXtmp=0;
  if (FXtmp>63) FXtmp=63;
  SetVol(index,FXtmp);
  }
}

void S3MToneSlide(unsigned char index, int lo)
{
if (MixChannel[index].Speed) MixChannel[index].Period=IntToFixed(PitchAdjuster)/MixChannel[index].Speed; // Dividing 2 fixed numbers will return an integer

lo+=MixChannel[index].Period;
if (lo<=0) lo=100;
MixChannel[index].Speed=AssignFixed( (float) PitchAdjuster / (lo) );
} // Much Thanks to author of S3Mod for pointing me in the right direction for this

void S3MPortto(unsigned char index, unsigned char val, unsigned char NextEffect) // Tone Portamonto
{
if (song.SpeedCount)
  {
  if (MixChannel[index].FXParam2)
    {
    S3MToneSlide(index,val<<7);
    if (MixChannel[index].Speed<MixChannel[index].FXParam1)
      {
      MixChannel[index].Speed=MixChannel[index].FXParam1;
      MixChannel[index].Effect=NextEffect; // If this is done porting to a note, set it to the other effect in case if there was one
      }
    }
   else
    {
    S3MToneSlide(index,-(val<<7));
    if (MixChannel[index].Speed>MixChannel[index].FXParam1)
      {
      MixChannel[index].Speed=MixChannel[index].FXParam1;
      MixChannel[index].Effect=NextEffect; // If this is done porting to a note, set it to the other effect in case if there was one
      }
    }
  }
}

void S3MDoRetrigVolChanges()  // I garantee there are a few lost people out there trying to decipher this function.
{
hi=MixChannel[index].Value>>4;
FXtmp=MixChannel[index].RealVol;
if (hi<=0x5)  // If its in the subtract vol range
  {
  if (hi) // If hi isn't zero
     FXtmp-=(1 << (hi-1)); // Subtract volume
       // else do nothing because it is zero and zero does nothing
  }
 else // Else if its in the add vol range
//---------------------------
if ( (hi>=0x9) && (hi<=0xd ))  //
  {
  FXtmp+=(1 << (hi-9));  //Add volume
  }
 else
//------------------------------
  switch (MixChannel[index].Value>>4)
    {
    case 6   : FXtmp=(FXtmp*2)/3; break;
    case 7   : FXtmp>>=1;       break; // div by 2
    case 8   : FXtmp=(FXtmp);     break; // I have no idea what Scream Tracker 3 means by '?' but it that it appears to do nothing when retriged with the value
    case 0xe : FXtmp=(FXtmp*3)/2; break;
    case 0xf : FXtmp<<=1;       break; // mult by 2
    }
if (FXtmp>64) FXtmp=64;
if (FXtmp<0) FXtmp=0;

SetVol(index,FXtmp);
}

unsigned char AddNote(unsigned char a, unsigned char b)
{
unsigned char tmp;

hi=a>>4;
lo=a&0xf;
tmp=(hi*12)+lo;  // Calculate non-hex seperated note
//printf("Source=%x : NHSN=%d + %d = ",a, tmp,b);
tmp+=b;          // Add the note
//printf("%d\n",tmp);

a=((tmp / 12)<<4)+(tmp % 12); // put it back into hex-seperated note
//printf("Back to %x \n",a);
return(a);
}

void HandleEffects()
{
for (index=0;index<MaxChannels;index++)  // Go through all 32 Channels;
  {
  switch (MixChannel[index].Effect) // Which Effect are we doing, 0 if none
    {
    case EfJumpOrder : MixChannel[index].Effect=0;
                       ordnum=MixChannel[index].Value;
                       ChangeOrder(ordnum);
                       break;
    case EfBreakPattern :
                        ChangeOrder(++ordnum);
                        SeekRow(MixChannel[index].Value);
                        MixChannel[index].Effect=0;
                        break;  // Break to next pattern row

    case EfFadeVolume : S3MVolSlide(index,MixChannel[index].Value);break;

    case EfVibVolSlide : S3MVolSlide(index,MixChannel[index].Value); // Dual effect, mosey on over to the other one

    case EfFineVibrato :
    case EfVibrato : {
                     if (MixChannel[index].InitFX&1) // Bit 1 is true if a when a note is played.
                             {
                             MixChannel[index].InitFX&=0xfe; // &=11111110 turn off bit 1
                             MixChannel[index].VibratoPos=0;
                             MixChannel[index].CenterSpeed=MixChannel[index].Speed; // This is where the Vibrato is centered around :)

//                             printf("CenterSpeed=%d %d  \n",FixedToInt(MixChannel[index].CenterSpeed),MixChannel[index].CenterSpeed&0xffff);
                             }
                     if (song.SpeedCount)
                       {
                       hi=MixChannel[index].VibValue >> 4;
                       lo=MixChannel[index].VibValue & 0x0f;

                       MixChannel[index].Speed=MixChannel[index].CenterSpeed;
                       if (MixChannel[index].VibratoPos<=31) // Do we go down or up
                         {

                         if (MixChannel[index].Effect==EfVibrato) // If its not fine vibrato
                           S3MToneSlide(index,SinTable[MixChannel[index].VibratoPos]*lo); // Increasing period makes pitch go down, so go down.
                          else
                           S3MToneSlide(index,(SinTable[MixChannel[index].VibratoPos]*lo) >> 2 ); // Increasing period makes pitch go down, so go down.

                         MixChannel[index].VibratoPos+=hi;

//                         printf("Vibrato Pos=%d \n",MixChannel[index].VibratoPos);
                         }
                        else
                         {
                         if (MixChannel[index].Effect==EfVibrato)
                           S3MToneSlide(index,SinTable[MixChannel[index].VibratoPos & 0x1f]*-lo); // Decreasing period makes pitch go up, hence go up
                          else
                           S3MToneSlide(index,-(SinTable[MixChannel[index].VibratoPos & 0x1f]*lo) >> 2 ); // Decreasing period makes pitch go up, hence go up
                         MixChannel[index].VibratoPos+=hi;
//                         printf("Vibrato Pos=%d \n",MixChannel[index].VibratoPos);
                         if (MixChannel[index].VibratoPos>=64) // Time to loop?
                           {
                           MixChannel[index].VibratoPos-=64;
                           }
                         }
                       }
                     } break;

    case EfTremolo : {
                     if (MixChannel[index].InitFX&TremoloBit) // Bit 2 is true if a when a note is played.
                             {
                             MixChannel[index].InitFX&=0xfd; // &=11111101 turn off bit 2
                             MixChannel[index].VibratoPos=0;
                             MixChannel[index].CenterSpeed=MixChannel[index].Speed; // This is where the Vibrato is centered around :)
                             }
                     if (song.SpeedCount)
                       {
                       hi=MixChannel[index].Value >> 4;
                       lo=MixChannel[index].Value & 0x0f;

                       FXtmp=MixChannel[index].RealVol;
                       if (MixChannel[index].VibratoPos<=31) // Do we go down or up
                         {
                         FXtmp+=(SinTable[MixChannel[index].VibratoPos]*lo) >> 7; // Starts out vol going up
                         MixChannel[index].VibratoPos+=hi;
                         }
                        else
                         {
                         FXtmp-=(SinTable[MixChannel[index].VibratoPos & 0x1f]*lo) >> 7; // Vol Goes down
                         MixChannel[index].VibratoPos+=hi;
                         if (MixChannel[index].VibratoPos>=64) // Time to loop?
                           MixChannel[index].VibratoPos-=64;
                         }
                       if (FXtmp >= 64) FXtmp=64;
                       if (FXtmp < 0) FXtmp=0;
                       SetVol(index,FXtmp);
                       }
                     } break;

    case EfSlideDn : hi=MixChannel[index].Value >> 4;
                     lo=MixChannel[index].Value & 0x0f;
                     switch (hi)
                      {
                      case 0xe: if (!song.SpeedCount)
                                  S3MToneSlide(index,lo<<5);
                                break;
                      case 0xf: if (!song.SpeedCount)
                                  S3MToneSlide(index,lo<<7);
                                break;
                      default : if (song.SpeedCount)
                                  S3MToneSlide(index,MixChannel[index].Value<<7);
                                break;
                      }
                     break;
    case EfSMPOfs  : {
                     tmp=MixChannel[index].Value << (NumFixedBits+8);  // Make it a fixed number and shift left 8 at the same time
                     if (FixedToInt(tmp)>=MixChannel[index].SMPLength) tmp=0;
                     MixChannel[index].Pos=tmp;
                     MixChannel[index].Effect=0;
                     }  // Could have a problem if Song keeps calling O (will be like a looped sample?)
    case EfSlideUp : hi=MixChannel[index].Value >> 4;
                     lo=MixChannel[index].Value & 0x0f;
                     switch (hi)
                      {
                      case 0xe: if (!song.SpeedCount)
                                  S3MToneSlide(index,-(lo<<5));
                                break;
                      case 0xf: if (!song.SpeedCount)
                                  S3MToneSlide(index,-(lo<<7));
                                break;
                      default : if (song.SpeedCount)
                                  S3MToneSlide(index,-(MixChannel[index].Value<<7));
                                break;
                      }

                     break;
    case EfAppregio : {
                      if (MixChannel[index].note<=0xa0) // Lets not appregio anything above 10 octives
                        {
                        switch (MixChannel[index].FXParam2++)
                          {
                          case 0 : MixChannel[index].Speed=CalcSpeed( AddNote(MixChannel[index].note,MixChannel[index].Value>>4 ),MixChannel[index].ins);break;
                          case 1 : MixChannel[index].Speed=CalcSpeed( AddNote(MixChannel[index].note,MixChannel[index].Value&0xf),MixChannel[index].ins);break;
                          case 2 : MixChannel[index].Speed=MixChannel[index].CenterSpeed;
                          }

                        if (MixChannel[index].FXParam2>=3)
                          MixChannel[index].FXParam2=0;
                        }
                       else
                        { // Note = 255
                        MixChannel[index].Effect=0; // Does no good to be calling this proc
                        }

                      } break;

    case EfGlissando : S3MPortto(index,MixChannel[index].GlissValue,0);break;

    case EfTremor : if ((MixChannel[index].FXParam2--)==0) // This doesn't work but who cares.  This effect is useless.
                      {
                      if (MixChannel[index].FXParam3) // Is the note currently on
                        {
                        MixChannel[index].FXParam3=0;
                        MixChannel[index].Vol=0;
                        MixChannel[index].FXParam2=(MixChannel[index].Value&0x0f); // Lo value is the # of beats to shut up
                        }
                      else
                        {
                        MixChannel[index].FXParam3=1; // Else turn it on
                        MixChannel[index].Vol=GVolume(MixChannel[index].FXParam1); // Restore original value
                        MixChannel[index].FXParam2=(MixChannel[index].Value >> 4); // Hi Value is the # of beats to be on
                        }
                      } break;

    case EfGlisVolSlide : {
                          S3MVolSlide(index,MixChannel[index].Value);
                          S3MPortto(index,MixChannel[index].GlissValue,EfFadeVolume);
                          } break;

    case EfSetSpeed  : {
                       song.Speed=MixChannel[index].Value;
                       SetTempo(song.Speed,song.Tempo);
                       MixChannel[index].Effect=0;
                       } break;  // Set Speed
    case EfRetrig : if (!MixChannel[index].FXParam3--)
                      {
                      MixChannel[index].Pos=0;  // Retrig to start
                      MixChannel[index].Playing=1; // Make sure tis still playing!
                      S3MDoRetrigVolChanges();
                      MixChannel[index].FXParam3=MixChannel[index].Value&0xf;
                      } break;
    case EfSetTempo : {
                      song.Tempo=MixChannel[index].Value;
                      SetTempo(song.Speed,song.Tempo);
                      MixChannel[index].Effect=0;
                      break; // Set Tempo
                      }
    case EfSetGVolume : {
                        SetGVolume(MixChannel[index].Value);
                        MixChannel[index].Effect=0;
                        break;
                        }
// Special Commands Here
    case EfNoteCut : if (!MixChannel[index].Value--)
                       {
                       MixChannel[index].Effect=0;
                       MixChannel[index].Playing=0;
                       }
                       break;
    case EfNoteDelay : if (!MixChannel[index].Value--)
                         {
                         MixChannel[index].Effect=0;
                         MixChannel[index].Value=0;
                         switch (MixChannel[index].note)
                           {
                           case 254 : MixChannel[index].Playing=0;break;
                           case 255 : break;
                           default  : InitNote(MixChannel[index].ins,index,MixChannel[index].note);break;
                           }
                         SetVol(index,MixChannel[index].FXParam3);
                         }
                         break;
    case EfSetPan : MixChannel[index].PanPos=MixChannel[index].Value;
                    SetVol(index,MixChannel[index].RealVol); // Update pan info
                    MixChannel[index].Effect=0;
                    break;
    }  // End Case
  }  // End For
} // End Function

void PlaySong()
{
if ((!playing)&&song.loaded)
  {
  stpor=SMPSPerRow;
  SetTempo(song.InitSpeed,song.InitTempo);
  ChangeOrder(0);  // Set Order to 0
  song.SpeedCount=0;
  song.GVolume=song.InitGVolume;
  playing=1;
  }
}

void StopSong()
{
playing=0;
}

// -------------------------------------------------------------------------
// -----------------------------The Mixer-----------------------------------
// -------------------------------------------------------------------------
unsigned char *Mix_BP;
void StartLockCodePtr()
{
}

void Mix8M(unsigned int HowManySMPS, unsigned int *Pos)
{
#ifdef DEBUG
MixerCalls++;
#endif

if (!HowManySMPS) { return; } // Make sure this isn't zero
/*(Mix_Start=MixBufPos;
Mix_End=MixBufPos+HowManySMPS;*/
Mix_Index=MixBufPos;
CurVolumeL=MixChannel[UDM_ChannelNum].Vol;
Mix_BP=MixBuff+MixBufPos;

do
  { //MixBuff[Mix_Index++]=ClipTable[(MixBuff[Mix_Index]) + VolumeTable[CurVolumeL][InsPtr[ FixedToInt(MixChannel[UDM_ChannelNum].Pos) ]]]; // Mix it and increment the MixChannel Position @ the same time
    *Mix_BP=ClipTable[*Mix_BP + VolumeTable[CurVolumeL][InsPtr[ FixedToInt(*Pos) ]]]; // Mix it
    Mix_BP++;
    (*Pos)+=Speed;
  } while (--HowManySMPS);
}

void Mix8S(unsigned int HowManySMPS, unsigned int *Pos)
{
#ifdef DEBUG
MixerCalls++;
#endif

if (!HowManySMPS) { return; } // Make sure this isn't zero
/*(Mix_Start=MixBufPos;
Mix_End=MixBufPos+HowManySMPS;*/
Mix_Index=MixBufPos;
CurVolumeL=MixChannel[UDM_ChannelNum].LVol;
CurVolumeR=MixChannel[UDM_ChannelNum].RVol;

Mix_BP=MixBuff+MixBufPos;

do
  { //MixBuff[Mix_Index++]=ClipTable[(MixBuff[Mix_Index]) + VolumeTable[CurVolume][InsPtr[ FixedToInt(MixChannel[UDM_ChannelNum].Pos) ]]]; // Mix it and increment the MixChannel Position @ the same time
    *Mix_BP=ClipTable[*Mix_BP + VolumeTable[CurVolumeL][InsPtr[ FixedToInt(*Pos) ]]]; // Mix it
    Mix_BP++;
    *Mix_BP=ClipTable[*Mix_BP + VolumeTable[CurVolumeR][InsPtr[ FixedToInt(*Pos) ]]]; // Mix it
    Mix_BP++;
    (*Pos)+=Speed;
  } while (--HowManySMPS);
}

void Mix8C(unsigned int HowManySMPS, unsigned int *Pos) // Optimized Center channel mixing
{
unsigned char tmp;
#ifdef DEBUG
MixerCalls++;
#endif

if (!HowManySMPS) { return; } // Make sure this isn't zero
/*(Mix_Start=MixBufPos;
Mix_End=MixBufPos+HowManySMPS;*/
Mix_Index=MixBufPos;
CurVolumeL=MixChannel[UDM_ChannelNum].LVol;
CurVolumeR=MixChannel[UDM_ChannelNum].RVol;

Mix_BP=MixBuff+MixBufPos;

do
  { //MixBuff[Mix_Index++]=ClipTable[(MixBuff[Mix_Index]) + VolumeTable[CurVolume][InsPtr[ FixedToInt(MixChannel[UDM_ChannelNum].Pos) ]]]; // Mix it and increment the MixChannel Position @ the same time
    tmp=VolumeTable[CurVolumeL][InsPtr[ FixedToInt(*Pos) ]]; // Mix it
    *Mix_BP=ClipTable[*Mix_BP + tmp];
    Mix_BP++;
    *Mix_BP=ClipTable[*Mix_BP + tmp];
    Mix_BP++;
    (*Pos)+=Speed;
  } while (--HowManySMPS);
}

void Mix8SL(unsigned int HowManySMPS, unsigned int *Pos) // Mix Left Channel
{
#ifdef DEBUG
MixerCalls++;
#endif

if (!HowManySMPS) { return; } // Make sure this isn't zero
Mix_Index=MixBufPos;
CurVolumeL=MixChannel[UDM_ChannelNum].LVol;
CurVolumeR=MixChannel[UDM_ChannelNum].RVol;

Mix_BP=MixBuff+MixBufPos;

do
  { *Mix_BP=ClipTable[*Mix_BP + VolumeTable[CurVolumeL][InsPtr[ FixedToInt(*Pos) ]]]; // Mix it
    Mix_BP+=2;
    (*Pos)+=Speed;
  } while (--HowManySMPS);
}


void Mix8SR(unsigned int HowManySMPS, unsigned int *Pos) // Mix Right Channel
{
#ifdef DEBUG
MixerCalls++;
#endif

if (!HowManySMPS) { return; } // Make sure this isn't zero
Mix_Index=MixBufPos;
CurVolumeR=MixChannel[UDM_ChannelNum].RVol;

Mix_BP=MixBuff+MixBufPos;

Mix_BP++; // Put it on track to mix the right channel
do
  { *Mix_BP=ClipTable[*Mix_BP + VolumeTable[CurVolumeR][InsPtr[ FixedToInt(*Pos) ]]]; // Mix it
    Mix_BP+=2;
    (*Pos)+=Speed;
  } while (--HowManySMPS);
}

inline void Mix(unsigned int HowManySMPS, unsigned int *Pos)
{
if (SBStereo)
  {
  switch (MixChannel[UDM_ChannelNum].PanPos)
    {
    case 0 :   Mix8SL(HowManySMPS, Pos); break;
    case 128 : Mix8SR(HowManySMPS, Pos); break;
    default : if (MixChannel[UDM_ChannelNum].RVol==MixChannel[UDM_ChannelNum].LVol)
                Mix8C(HowManySMPS,Pos);
               else
                Mix8S(HowManySMPS, Pos);
    }
  }
 else
  Mix8M(HowManySMPS, Pos);                  //Play as much as we can
}

void UpDateMixing(unsigned int HowManySMPS)  //This routine gives me a headache just looking at it.  AHHHHHHHHHH Make it stop!!!!!!!!!!1
{
//label TryAgain;

if (SBStereo)
  tmp=MixBufPos+HowManySMPS*2;
 else
  tmp=MixBufPos+HowManySMPS;

for (UDM_Index=MixBufPos;UDM_Index<=tmp;UDM_Index++)
  {
  MixBuff[UDM_Index]=128;
  }

for (UDM_ChannelNum=0;UDM_ChannelNum<=31;UDM_ChannelNum++)
  {
  if (MixChannel[UDM_ChannelNum].Playing)
   if (MixChannel[UDM_ChannelNum].Speed!=0)  // Makesure speed isn't 0 for safety reasons
    {

    InsPtr=DigINS[MixChannel[UDM_ChannelNum].SMPIndex].SMPData;
    Speed=MixChannel[UDM_ChannelNum].Speed;//DigINS[MixChannel[UDM_ChannelNum].SMPIndex].ScaleTable[1];

    UDM_SMPPlayAmount=HowManySMPS;
    if ( FixedToInt(MixChannel[UDM_ChannelNum].Pos+FixedMultEr(IntToFixed(HowManySMPS),Speed)) >= MixChannel[UDM_ChannelNum].LoopEnd-1)  // Are we Near an end of a sample
      {
        if (MixChannel[UDM_ChannelNum].LoopMode)  // If loop then
          {
          TMixBufPos=MixBufPos;      // Copy the mixbufpos so we can modify it
          UDM_Need2Mix=HowManySMPS;  // We need to mix the entire buffer

          LoopPeriod=IntToFixed(MixChannel[UDM_ChannelNum].LoopEnd-MixChannel[UDM_ChannelNum].LoopStart);
          tryagain:

          UDM_SMPPlayAmount=FixedToInt(FixedDiv(IntToFixed(MixChannel[UDM_ChannelNum].LoopEnd)-MixChannel[UDM_ChannelNum].Pos,Speed)); // This is how much we can play till right before loopend (trunc(playamount-pos/speed)
          if (UDM_SMPPlayAmount>UDM_Need2Mix)
            {
            Mix(UDM_Need2Mix, &MixChannel[UDM_ChannelNum].Pos);
            }
          else
            {
//            printf("Before mix : Pos=%d, LoopStart=%d LoopEnd=%d PlayAmount=%d Need2Mix=%d\n",FixedToInt(MixChannel[UDM_ChannelNum].Pos),MixChannel[UDM_ChannelNum].LoopStart, MixChannel[UDM_ChannelNum].LoopEnd, UDM_SMPPlayAmount, UDM_Need2Mix);
            Mix(UDM_SMPPlayAmount, &MixChannel[UDM_ChannelNum].Pos); //Play as much as we can

            if (SBStereo)
              MixBufPos+=UDM_SMPPlayAmount<<1;
             else
              MixBufPos+=UDM_SMPPlayAmount;

            UDM_Need2Mix-=UDM_SMPPlayAmount;
            MixChannel[UDM_ChannelNum].Pos-=LoopPeriod;
            if ( MixChannel[UDM_ChannelNum].Pos>IntToFixed(MixChannel[UDM_ChannelNum].SMPLength) ) // If we subtract and its higher than Sample Length, chances are we had a subtract underflow, and it is an extremely high number
              MixChannel[UDM_ChannelNum].Pos=0; // Set it to 0;
            goto tryagain;
            }


          MixBufPos=TMixBufPos; // Restore the Mix buff position.
          }
          else // no loop
            {
            UDM_SMPPlayAmount=FixedToInt(FixedDiv(IntToFixed(MixChannel[UDM_ChannelNum].LoopEnd)-MixChannel[UDM_ChannelNum].Pos,Speed));  // This is how much we can play (Length-POS)
            Mix(UDM_SMPPlayAmount, &MixChannel[UDM_ChannelNum].Pos);                  //Play as much as we can
            MixChannel[UDM_ChannelNum].Playing=0;    //Cut it off
            }
       }
      else // Don't need to deal with LoopEnd/SampleEnd
        {
        Mix(UDM_SMPPlayAmount, &MixChannel[UDM_ChannelNum].Pos);//Play the samps
                                                               //The Mixing Position is updated while its being mixed
        }  // Endif Sample End/Loop Check

    }  // Endif MixChan is playing
  } // End Channel Loop
if (SBStereo)
  MixBufPos+=HowManySMPS<<1;
 else
  MixBufPos+=HowManySMPS;
}  // End proc


void PollMixing()
{
if (pollflag)
  {
  pollflag=0;
  if (playing)
    {
    SMPSToMix=MixBlockSamples;

    while (SMPSToMix)
      {
      if (stpor>SMPSToMix)
        {
        UpDateMixing(SMPSToMix);
        stpor-=SMPSToMix;
        SMPSToMix=0;
        }
      else
        {
        if (stpor) UpDateMixing(stpor);
        SMPSToMix-=stpor;

        if (song.SpeedCount>=song.RowSpeed)
          {
          PlayRow();
          song.SpeedCount=0;
          }
         else song.SpeedCount++;

        HandleEffects();

//      MixBufPos+=stpor;  // Mixbufpos is automatically updated
        stpor=SMPSPerRow;
        }

      }
    }
   else
    {
    if (!donothing) UpDateMixing(MixBlockSamples);
    }//End if playing

  }//End if flag
}

void IntHandler()
{
//  Do this so the other IRQ interrupts can be called and it won't interfere
//  with the modem or something.  Also reduces risk of skipping.

pollflag=1;
flag=1;
Calls++;
    switch (CurBlockNum)
      {
      case 1 : {
                MixBufPos=0;
                CurBlockNum=2;
               } break;
      case 2 : {
                MixBufPos=MixBlockSize;
                CurBlockNum=1;
               }
      }

if (HighPriority) PollMixing();

outp(0xA0, 0x20);              /* Talk to PIC2       */
outp(0x20, 0x20);              /* Talk to PIC1       */
                               /* You gotta do this stuff so that this proc
                               will keep getting called :)                */
inp(DAPort);
}

void EndLockCodePTR()  // Use this so We know how much code to lock
{
}
// -------------------------------------------------------------------------
// -------------------------------End of the Mixer--------------------------
// -------------------------------------------------------------------------

unsigned char StartSound(unsigned char SMPNum, char Channel, char Volume, unsigned char NoteNum)
{
unsigned char Index;
char oct;

/*if (!DigINS[SMPNum].SMPLoaded)
  { return(-1); }*/
if (Channel=-1)
  {
  for (Index=16;Index<31;Index++)
    if (!MixChannel[Index].Playing)
      {
      Channel=Index;
      Index=32;
      }
  }


      disable();
      MixChannel[Channel].Playing=1;
      MixChannel[Channel].Pos=0;
      MixChannel[Channel].LoopMode=DigINS[SMPNum].LoopMode;
      MixChannel[Channel].LoopStart=DigINS[SMPNum].LoopStart;
      MixChannel[Channel].LoopEnd=DigINS[SMPNum].LoopEnd;
      MixChannel[Channel].SMPLength=DigINS[SMPNum].SMPLength;

      MixChannel[Channel].Speed=CalcSpeed(NoteNum,SMPNum);
/*      oct=NoteNum/12;
      if (oct<MidOctive)
        {
        MixChannel[Channel].Speed=DigINS[SMPNum].ScaleTable[NoteNum%12] >> (MidOctive-oct);  //Freq >>(7+(8-oct)) there are 8 possible octives
        } else
      if (oct>MidOctive)
        {
        MixChannel[Channel].Speed=DigINS[SMPNum].ScaleTable[NoteNum%12] << (oct-MidOctive);
        } else
          MixChannel[Channel].Speed=DigINS[SMPNum].ScaleTable[NoteNum%12];*/

      if (Volume>=0)
        {
        SetVol(Channel,Volume);
        } else
          {
          if (DigINS[SMPNum].DefaultVol>63)
            SetVol(Channel,63);
           else
            SetVol(Channel,DigINS[SMPNum].DefaultVol);
          }
      MixChannel[Channel].SMPIndex=SMPNum;
      enable();
      return(Channel);  //bail

}

unsigned char StopChannel(char ChannelNum)
{
disable();
if (ChannelNum=-1)
  {
  for (ChannelNum=0;ChannelNum<=31;ChannelNum++)
    MixChannel[ChannelNum].Playing=0;
  }
    else
    {
    MixChannel[ChannelNum].Playing=0;
    }
enable();
}

unsigned int fgetw(FILE *DaFile)
{
unsigned int tmp;
tmp=fgetc(DaFile);
tmp+=fgetc(DaFile) << 8;
return(tmp);
}

void SetMasterVol(unsigned char mv)
{
unsigned int VolIndex;
unsigned char VolLevel;
if (SBStereo)
  {
  mv=(mv*11)/16; // Amplify by 11/8  (MV is divided by two no matter what
  }
 else
  {
  mv=(mv/2); // reduce it to 2/3 the volume
  }
printf("%d\n",mv);
for (VolLevel=0; VolLevel<=63; VolLevel++)
  for (VolIndex=0; VolIndex<=255; VolIndex++)
	 VolumeTable[VolLevel][VolIndex] = ( ( ((VolIndex-127)*(VolLevel)) / (64) ) * mv)/128 + 127;
	 //( ((VolIndex-127) * (VolLevel+1) * mv) / (128*64) )+127;
}


