// ************************************************************************
//                /////            -/      /|    /                  |\
//   |\          /                 /      / |   /|             |\   |
//   |\          \\\\             /      /  |  / |             |\ /\|
// /\|               \  /\ /\  * /      /   | /  |  * |/     /\|  \/
// \/            ///// / / -/ / /      /    |/   | /  /|     \/
//
// Snail Mix Digital Audio Library, CopyRight(C) 1998 Timothy Curtis Harper
// ************************************************************************
// THIS LIBRARY IS PROVIDED AS AN "AS IS" BASIS.  THE AUTHOR IS NOT
// RESPONSIBLE FOR ANY INCONSEQUENTIAL DAMAGE THAT MAY OCCURE BY COMPILING
// THIS SOURCE.  READ "README.TXT" FOR MORE DETAILS
// ************************************************************************
//            See updates, news, and download new version at
//                 http://members.tripod.com/~SaltySnail
/////////////////////////////////////////////////////////////////////////////

// SB Stuff
// Initialization, irq, install handler, etc

#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <crt0.h>
#include <sys/nearptr.h>
#include <dpmi.h>
#include "mixer.h"
#include "fixed.h"

typedef struct { UCHAR addr, count, page, mask, mode, FF;
                 } dmaportstruct;

const dmaportstruct dmaports[8] = {
          {0x00, 0x01, 0x87, 0x0A, 0x0B, 0x0C},  // chan 0
          {0x02, 0x03, 0x83, 0x0A, 0x0B, 0x0C},  // chan 1
          {0x04, 0x05, 0x81, 0x0A, 0x0B, 0x0C},  // chan 2  DON'T USE
          {0x06, 0x07, 0x82, 0x0A, 0x0B, 0x0C},  // chan 3
          {0x00, 0x00, 0x00, 0xD4, 0xD6, 0xD8},  // chan 4  DON'T USE
          {0xC4, 0xC6, 0x8B, 0xD4, 0xD6, 0xD8},  // chan 5
          {0xC8, 0xCA, 0x89, 0xD4, 0xD6, 0xD8},  // chan 6
          {0xCC, 0xCE, 0x8A, 0xD4, 0xD6, 0xD8}   // chan 7
      };

dmaportstruct dmaport; // define dmaport variable

extern void InitMixing();
extern void StartLockCodePtr();
extern void EndLockCodePTR();
extern void IntHandler();

unsigned char SB16Bit, SBStereo;
//---------------------------------------------IRQ Vars
static int PICRotatePort;
static int PICMaskPort;
static int IRQStartMask;
static int IRQStopMask;
static int IRQIntVector;
//---------------------------------------------DMA Vars
unsigned int DMAStartMask;
unsigned int DMAStopMask;
unsigned int DMAMode;
unsigned int DMALength;

unsigned char *MixOutMem, *MixBuff, *Tables;
unsigned char MixOutMemSelector;

unsigned int SamplingRate=DefaultSamplingRate;
unsigned int SNDIntPort;
unsigned int SBIOAddr;
unsigned char SBIRQ, SBDMA;

unsigned long int BufferAddr;
unsigned int BufferPage,BufferOfs;
char SBLoopMode=0;                     // If SB Ver >2.00 then enable
                                       // looping to get rid of annoying click
unsigned int MixBlockSize, MixBuffSize;// Define how big the buffer is in Bytes

char HandlerInstalled=0;
_go32_dpmi_seginfo OldIRQIntHandler;
_go32_dpmi_seginfo pmint;

unsigned int DSPVer=0x100,ResetPort=0x220,ReadPort=0x220,WritePort=0x220,DAPort=0x220;

static union REGS DaRegs;

/*Pre-initialize so if any idiot runs a certian function w/out initializing the
mixer it won't screw him over (This is exluding myself =) */

void * MK_FP (unsigned short seg, unsigned short ofs)        //I just grabbed this
{                                                            //section out of the FAQ
if ( !(_crt0_startup_flags & _CRT0_FLAG_NEARPTR) )           //DJGPPFAQ.TXTf:
  if (!__djgpp_nearptr_enable ())                            //Hey, it works!!!!!!!
    return (void *)0;                                        //Courtesy of --
return (void *) (seg*16 + ofs + __djgpp_conventional_base);  //Charles Sandman
}

void WriteDSP(unsigned char what)
{
while ((inportb(WritePort) & 0x80)) {;}
outportb(WritePort,what);
}

unsigned char ReadDSP()
{
while (!(inportb(DAPort) & 0x80)) {;}
return(inportb(ReadPort));
}

char SBReset()
{
unsigned char i;

outp(ResetPort,1);

Waittick(20);
outp(ResetPort,0);
i=1;
while ((ReadDSP()!=0xAA) && (++i < 75)) {}

if (i<75) return(1); else return(0);
}

unsigned char TMP;

void TempIntHandler()
{
TMP=1;
inp(DAPort); // Acknowledge DCK port
}

void SetupDMA(unsigned char DMA_Mode, unsigned short int OFS, unsigned short int Length)
{
outp(dmaport.mask,   DMAStopMask);
outp(dmaport.FF, 0x00);
outp(dmaport.mode,   DMA_Mode); // Single Cycle Dma mode
outp(dmaport.addr,   LO(OFS));                 //Where 2 play
outp(dmaport.addr,   HI(OFS));
outp(dmaport.count,  LO(Length));               //Play Length that is fed in
outp(dmaport.count,  HI(Length));
outp(dmaport.page,   BufferPage);
outp(dmaport.mask,   DMAStartMask);
}

void InstallHandler()
  {

    if (HandlerInstalled) return;    // Why install the Handler twice????
    disable();                       // Disable interrupts
    outportb(PICMaskPort, (inportb(PICMaskPort) | IRQStopMask));  //Turn off IRQ ints

    pmint.pm_selector = _my_cs();
    pmint.pm_offset = (unsigned)&IntHandler;

    _go32_dpmi_get_protected_mode_interrupt_vector(IRQIntVector, &OldIRQIntHandler);  //Save original interrupt
    _go32_dpmi_chain_protected_mode_interrupt_vector(IRQIntVector, &pmint); // Stick our int there.  Hahahahhaha

    outp(PICMaskPort, (inportb(PICMaskPort) & IRQStartMask));    //Turn IRQ ints bak on
    enable();                        // Enable interrupts

    HandlerInstalled = 1;            // Its been installed
  }

void UninstallHandler(void)
  {
    if (!HandlerInstalled) return;   // Can't Uninstall something thats not installed
    disable();                       // Turn off ints
    outportb(PICMaskPort, (inportb(PICMaskPort) | IRQStopMask));  //Turn off IRQ ints

    _go32_dpmi_set_protected_mode_interrupt_vector(IRQIntVector, &OldIRQIntHandler);  // I'm feeling nice so I guess I can give this back to the system
    enable();                        // Ints bak on

    HandlerInstalled = 0;            // Its outta there
  }


int StartOutput()
{
unsigned char TimeConstant;

InstallHandler(); //Install the DMA handler
//program DMA controller
SetupDMA(DMAMode, BufferOfs, DMALength-1);

if (SBStereo)
  {
  outp(SBIOAddr+0x04,0xE);
  TMP=inp(SBIOAddr+0x05);
  outp(SBIOAddr+0x05, TMP | 0x20);
  }

TimeConstant = 256 - (1000000 / SamplingRate);    //Set the sampling rate
SamplingRate=-1000000 / (TimeConstant-256);       //Make Sure Sampling rate is the same as what the speakers are doing
//printf("SR=%d TC=%d\n",SamplingRate,TimeConstant);

WriteDSP(0x40);
WriteDSP(TimeConstant);

WriteDSP(0xD1);                  //Turn on speaker

if (SBLoopMode)
  {
  if (DSPVer>=0x400)
    {
    WriteDSP(0xc6); // 8 bit, Fifo, autoinit, DAC transfer
    if (SBStereo)
      {
      WriteDSP(0x20); // Mode bit = Stereo and unsigned
      }
     else
      {
      WriteDSP(0); // Mode bit = Mono and unsigned
      }
    WriteDSP(LO(MixBlockSize-1)); // Write the length to the chip
    WriteDSP(HI(MixBlockSize-1));
    }
   else
    {
    if (SBStereo)
      {
      WriteDSP(0x48);
      WriteDSP(LO((MixBlockSize>>1)-1));
      WriteDSP(HI((MixBlockSize>>1)-1));
      WriteDSP(0x90);
      }
     else
      {
      WriteDSP(0x48);
      WriteDSP(LO((MixBlockSize)-1));
      WriteDSP(HI((MixBlockSize)-1));
      WriteDSP(0x1c);
      }
    } // Do it the old way
  }
else
  { //8 bit non looping:  SB (DSP 1.xx+)        Yah right!!!!!!!!!!!!!! :P
    //If you own a sound card that cheap I pity you...  GO GET AN AWE64 GOLD!
    WriteDSP(0x14);             //  8-bit single-cycle DMA output
    WriteDSP(LO(MixBlockSize-1));
    WriteDSP(HI(MixBlockSize-1));
  }
return(1);
}

int GetSBSettings()
{
char *BLASTER, *eb;
unsigned char pos=0;

if ( ( BLASTER = (char *) getenv("BLASTER"))==NULL)
  {
  return(0); // Return failure
  }
 else
  {
  while (*BLASTER!='\0')
    {
    switch (*(BLASTER++))
      {
      case 'A' :
      case 'a' : SBIOAddr=strtol(BLASTER,&eb,16); break;

      case 'I' :
      case 'i' : SBIRQ=strtol(BLASTER,&eb,10); break;

      case 'D' :
      case 'd' : SBDMA=strtol(BLASTER,&eb,10); break;

      default : eb=BLASTER; break;
      }
    BLASTER=eb;
    }
  }
return(1); // success!
}

char InitMixer(unsigned int IOAddr, unsigned char IRQ, unsigned char DMA, unsigned char _stereo, unsigned char _16Bit)
{
unsigned long int DecAddr;
unsigned int index;
float tmpvol;

if (IOAddr==0)
  {
  if (!GetSBSettings()) return(-1);
  }
 else
  {
  SBIOAddr=IOAddr;    //Stick the Info into Global Variables.
  SBIRQ   =IRQ;
  SBDMA   =DMA;
  }

/////////////////////////////////////////////////////
//SB16Bit=_16Bit; // SB16Bit doesn't work yet      //
/////////////////////////////////////////////////////
SB16Bit=0;
SBStereo=_stereo;
PitchAdjuster=(22222*22222)/SamplingRate; // Compute the PitchAdjuster
  //for Pitch Bends for the current sampling rate

ResetPort=SBIOAddr+0x06;      //Set up the differ PortVars
ReadPort =SBIOAddr+0x0A;
WritePort=SBIOAddr+0x0C;
DAPort   =SBIOAddr+0x0E;


DSPVer=0;
if (!SBReset()) {return(SBNotFound);}   //Detect SB card and bail if not found

WriteDSP(0xE1);                         //These 3 lines detect DSP version
DSPVer=ReadDSP() << 8; DSPVer+=ReadDSP();
if (DSPVer>0x200) { SBLoopMode=1;}
                  else { SBLoopMode=0;}

if (DSPVer<0x300) // if its better than 3.0 than Stereo is possible
  {
  SBStereo=0; // Turn off stereo if its been enabled.
  }
song.GVolume=MaxGVolume; // Turn up GVolume all the way

// Calculate the size of the Mix Buffer
MixBlockSize=MixBlockSamples;
if (SBStereo) MixBlockSize*=2; // Stereo?  Double memory usage
if (SB16Bit) MixBlockSize*=2; // 16 Bit?  Double memory usage again

MixBuffSize=MixBlockSize*2;  // 2 Blocks in a buffer
//printf("MixBlockSamples=%d, MixBlockSize=%d, MixBuffSize=%d\n",MixBlockSamples,MixBlockSize, MixBuffSize);

DaRegs.d.eax = 0x0100;                      /* Func, 0x100, Alloc Dos Mem. */
DaRegs.d.ebx = ((MixBuffSize*2) + 32) >> 4; /* # of paragraphs to eat      */
                                            // + 32 for safety
int86(0x31, &DaRegs, &DaRegs);              /* Call DPMI server            */
if( DaRegs.x.cflag ) return (OutOfMem);


MixOutMemSelector=DaRegs.d.edx;

DecAddr =  ((DaRegs.d.eax&0xffff)<<4);
if ((MixBuff=MK_FP(DecAddr/16,0))==NULL)
  { return(OutOfMem);}

if ( (DecAddr % 65536)+MixBuffSize < 65536)  // Make sure we don't cross pages
  {
  if ((MixBuff=MK_FP(DecAddr/16,0))==NULL)
    { return(OutOfMem);}

  }
    else
      {
      DecAddr+=MixBuffSize;
      if ((MixBuff=MK_FP(DecAddr/16,0))==NULL)
        { return(OutOfMem);}
      }

// Set up the Player--------------------------------------------------
for (index=0;index<=MixBuffSize;index++)  //Set buffer samps to middle (mute)
  {
  MixBuff[index]=128;
  }

CurBlockNum=1;

for (index=0;index<=DigInsNum;index++)   //Set all smps to not loaded
  {
  DigINS[index].SMPLoaded=0;
  }
for (index=0;index<=31;index++)   //Init Mixchannels
  {
  MixChannel[index].Effect=0;
  MixChannel[index].Value=0;
  MixChannel[index].Vol=0;
  MixChannel[index].RealVol=0;
  MixChannel[index].Speed=0;
  MixChannel[index].Pos=0;
  MixChannel[index].Playing=0;
  MixChannel[index].FXParam2=0;
  MixChannel[index].PanPos=64;
  }
// Set up the VolumeTable

SetMasterVol(128);

// Set up the Clipping Table

for (index=0;index<=127;index++)   { ClipTable[index]=0; }
for (index=128;index<=382;index++) { ClipTable[index]=index-127; }
for (index=383;index<=512;index++) { ClipTable[index]=255; }

/*_go32_dpmi_lock_code(StartLockCodePtr,(unsigned long) (EndLockCodePTR - StartLockCodePtr));
_go32_dpmi_lock_data(&MixBuff,MixBuffSize*2);
_go32_dpmi_lock_data(&VolumeTable,64*256);*/

// Set up IRQ parameters
if (SBIRQ < 8)
  {  /* PIC1 */
    IRQIntVector  = 0x08 + SBIRQ;
    PICMaskPort   = 0x21;
  }
 else
  { /* PIC2 */
    IRQIntVector  = 0x70 + SBIRQ-8;
    PICMaskPort   = 0xA1;
  }
IRQStopMask  = 1 << (SBIRQ % 8);
IRQStartMask = ~IRQStopMask;

// Set up DMA parameters;

BufferAddr=DecAddr;
BufferPage=BufferAddr  / 65536;
BufferOfs =BufferAddr  % 65536;

dmaport=dmaports[SBDMA];

/*switch (SBDMA)
  {
  case 0 : { DMAPagePort=0x87;}break;
  case 1 : { DMAPagePort=0x83;}break;
  case 2 : { DMAPagePort=0x81;}break;
  case 3 : { DMAPagePort=0x82;}break;
  }
DMAMaskPort    = 0x0A;
DMAClearPtrPort= 0x0C;
DMAModePort    = 0x0B;
DMAAddrPort    = (2*SBDMA);
DMACountPort   = (2*SBDMA)+1;*/

DMAStopMask  = SBDMA + 4;
DMAStartMask = SBDMA;

if (SBLoopMode)
  {
  DMAMode    = SBDMA + 0x58;
  DMALength  = MixBuffSize;
  } else
      {
      DMAMode    = SBDMA + 0x48;
      DMALength  = MixBuffSize/2;  //This section not implemented yet :(
      }

SNDIntPort = SBIOAddr + 0x00E;
if (!StartOutput())
 {
 return(SBNotFound);
 }
return(Success);
}

void StopOutput()
{
WriteDSP(0xd0);     //Turn Speaker Off
}

void KillMixer()
{
static union REGS DaRegs;
unsigned char Index;

UninstallHandler();
StopOutput();

DaRegs.d.eax = 0x0101;                      /* Func, 0x100, Alloc Dos Mem. */
DaRegs.d.ebx = MixOutMemSelector;           /* The DPMI driver returned    */
                                            // this number as a selector for the memory
int86(0x31, &DaRegs, &DaRegs);              /* Call DPMI server            */

//for (Index=0;Index<=
for (Index=0;Index<=99;Index++)
  {
  if (DigINS[Index].SMPLoaded)
    {
    DigINS[Index].SMPLoaded=0;
    free(DigINS[Index].SMPData);  // Kill Sample Data
    }
  }
DaRegs.d.eax = 0x0101;           /* DPMI free DOS memory */
DaRegs.d.edx = MixOutMemSelector;     /* base selector */
int86 (0x31, &DaRegs, &DaRegs);
}

