// ************************************************************************
//                /////            -/      /|    /                  |\
//   |\          /                 /      / |   /|             |\   |
//   |\          \\\\             /      /  |  / |             |\ /\|
// /\|               \  /\ /\  * /      /   | /  |  * |/     /\|  \/
// \/            ///// / / -/ / /      /    |/   | /  /|     \/
//
// Snail Mix Digital Audio Library, CopyRight(C) 1998 Timothy Curtis Harper
// ************************************************************************
// THIS LIBRARY IS PROVIDED AS AN "AS IS" BASIS.  THE AUTHOR IS NOT
// RESPONSIBLE FOR ANY INCONSEQUENTIAL DAMAGE THAT MAY OCCURE BY COMPILING
// THIS SOURCE.  READ "README.TXT" FOR MORE DETAILS
// ************************************************************************
//            See updates, news, and download new version at
//                 http://members.tripod.com/~SaltySnail
/////////////////////////////////////////////////////////////////////////////
#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <crt0.h>
#include <dir.h>
#include <sys/nearptr.h>
#include <dpmi.h>
#include <process.h>
#include "mixer.h"
#include "fixed.h"
#include "allegro.h"

#define ViewBMP     1
#define ViewOsc     2
#define ViewInf     3
#define ViewLoadS3M 4

#define OscWidth 640
#define OscHeight 480

#define IT_HX 0
#define IT_HY 0
#define IT_IX 0
#define IT_IY 1

#define IT_BX1 0  // Border value
#define IT_BY1 2
#define IT_BX2 79
#define IT_BY2 35 // Border value
#define IT_BC 15  // Color of border
#define IT_C1X 1  // Column 1 X value
#define IT_C2X 4  // Column 1 X value
#define IT_C3X 34  // Column 1 X value
#define IT_C4X 39  // Column 1 X value
#define IT_C5X 41  // Column 1 X value
#define IT_C6X 47  // Column 1 X value

#define IT_INC 15  // Ins Name colors
#define IT_InsPC 9 // If ins is playing, color of number
#define IT_InsNPC 1 // If ins isn't playing, color of number

char lh1='H';
unsigned int x, y;
char li1='i';
char la1='a'; // Encrypt my name just for the heck of it.  Just to make you wonder, that all....

unsigned int temp;
unsigned int index, cycles;
unsigned char *text_buf;// = (unsigned char *)0xB8000000L;
unsigned char View=ViewBMP;
char tmpstr[100];
char done;
struct ffblk sr;
char le1='e';
char lc1='C';
char filelist[80];
BITMAP *the_image, *buffer;
PALLETE the_pallete;
char lt1='T';
char lm1='m';
unsigned char ChanStarted;
unsigned char leave=0;
char lp1='p';
unsigned char N1,N2,N3,N4,N5,N6,N7,N8,N9;
char vol=32, note=64;
FILE *VolTable;
char lr1='r';
char ls1=' ';

void dwritexy(unsigned char x, unsigned char y, unsigned char c, unsigned char pc)
{
text_buf[(x+(y << 6) + (y << 4)) << 1]=pc;
text_buf[((x+(y << 6) + (y << 4)) << 1)+1]=c;
}

char fileexists(char *name)
{
FILE *f;
if ( (f=(FILE *) fopen(name,"r"))==NULL)
  {
  return(0);
  }
 else
  {
  fclose(f);
  return(1);
  }
}

void dwritexystr(unsigned char x, unsigned char y,unsigned char color, char *what)
{
unsigned char num;
for (num=0;num<strlen(what);num++) // Don't print Null Character at end of string
  {
  dwritexy(x+num,y,color,what[num]);
  }
}

void dclear(unsigned char x, unsigned char y,unsigned char color, unsigned int howmany, char what)
{
unsigned char num;
for (num=0;num<howmany;num++)
  {
  dwritexy(x+num,y,color,what);
  }
}

void InitInfoScreen()
{
textmode(C4350); // Set it 80x50

sprintf(tmpstr,"Snail Mix Version 1.0 by %c%c%c %c. %c%c%c%c%c%c  Playing : %s\0",lt1,li1,lm1,lc1,lh1,la1,lr1,lp1,le1,lr1,song.name);
dwritexystr(IT_HX,IT_HY,(1<<4)+9,tmpstr);
x=strlen(tmpstr);
dclear(IT_HX+x,IT_HY,(1<<4)+9,79-x,' ');

dwritexy(IT_BX1,IT_BY1,IT_BC,'');
dwritexy(IT_BX1,IT_BY2,IT_BC,'');
dwritexy(IT_BX2,IT_BY1,IT_BC,'');
dwritexy(IT_BX2,IT_BY2,IT_BC,'');

for (x=IT_BX1+1;x<IT_BX2;x++)
  {
  dwritexy(x,IT_BY1,IT_BC,'');
  dwritexy(x,IT_BY2,IT_BC,'');
  }

dwritexy(IT_C2X-1,IT_BY1,IT_BC,'');
dwritexy(IT_C2X-1,IT_BY2,IT_BC,''); // Column Borders
dwritexy(IT_C3X-1,IT_BY1,IT_BC,'');
dwritexy(IT_C3X-1,IT_BY2,IT_BC,''); // Column Borders
dwritexy(IT_C4X-1,IT_BY1,IT_BC,'');
dwritexy(IT_C4X-1,IT_BY2,IT_BC,''); // Column Borders
dwritexy(IT_C5X-1,IT_BY1,IT_BC,'');
dwritexy(IT_C5X-1,IT_BY2,IT_BC,''); // Column Borders

for (y=IT_BY1+1;y<IT_BY2;y++)
  {
  dwritexy(IT_BX1,y,IT_BC,'');
  dwritexy(IT_BX2,y,IT_BC,'');

  dwritexy(IT_C2X-1,y,IT_BC,'');
  dwritexy(IT_C3X-1,y,IT_BC,'');
  dwritexy(IT_C4X-1,y,IT_BC,'');
  dwritexy(IT_C5X-1,y,IT_BC,'');
  }
}

void InitBMP()
{
set_gfx_mode(GFX_AUTODETECT, 640, 480, 0, 0);
set_pallete(the_pallete);
blit(the_image, screen, 0, 0, (SCREEN_W-the_image->w)/2,(SCREEN_H-the_image->h)/2, the_image->w, the_image->h);
View=ViewBMP;
}

void strscan(char *strdata)
{
unsigned char x, y, pos=0;
char c;
y=wherey();
x=wherex();
while (!kbhit()) { if (!HighPriority) PollMixing();}
c=getch();
while (c!=13 && c!=27)
  {
  if (c==8) // backspace
    {
    if (pos)
      {
      pos--;
      putch(c);
      putch(' ');
      putch(c);
      }
    }
   else
    {
    strdata[pos++]=c;
    putch(c);
    }
  while (!kbhit()) { if (!HighPriority) PollMixing();}
  c=getch();
  }
strdata[pos++]=0; // Null terminator
if (c==27) strdata=NULL; //return no string
}

void PickS3M()
{
unsigned char index;
set_gfx_mode(GFX_TEXT, 80, 50, 0, 0);
textmode(C4350); // Set it 80x50
tryloadagain:
clrscr();

done=findfirst("*.",&sr,FA_DIREC);
index=0;
while (!done)
  {
  index++;
  if ((index%5)==0)
  printf("\n");

  if (sr.ff_attrib==16)  // if attrib is directory
    {
    strcat(sr.ff_name,"\\"); // add a \ on the end of it
    printf("%-15s", sr.ff_name);
    }

  done = findnext(&sr);
  }

done=findfirst("*.s3m",&sr,0);
while (!done)
  {
  index++;
  if ((index%5)==0)
    printf("\n");

  printf("%-15s", sr.ff_name);
  done = findnext(&sr);
  }
printf("\n");
printf("Enter the song to load ->\n");
//scanf("%s\13",filelist);
strscan(filelist);

if (fileexists(filelist))
  {
  DestroyS3M();
  LoadS3M(filelist);
  PlaySong();
  }
 else
  {
  if (!chdir(filelist)) // Chdir returns nonzero if not successful
   goto tryloadagain;
  }
}

int main(int argc, char *argv[])
{
unsigned char dostereo=1;
unsigned char VOC1, VOC2;
text_buf = (unsigned char *) MK_FP(0xB800,0000);
clrscr();

for (index=1;index<argc;index++)
    {
    printf("%s\n",argv[index]);
    if (argv[index][0]!='/')
      {
      strcpy(filelist,argv[1]);
      }
     else
      {
      if (strcmp(argv[index],"/HIGH")==0)
        {
        HighPriority=1;
        }
      if (strcmp(argv[index],"/NOSTEREO")==0)
        {
        dostereo=0;
        }
      if (strcmp(argv[index],"/?")==0)
        {
        printf("Snail Mix, V1.0 by %c%c%c %c. %c%c%c%c%c%c",lt1,li1,lm1,lc1,lh1,la1,lr1,lp1,le1,lr1); // Hehehe, had fun with that :)
        printf(" /?         This Help\n");
        printf(" /HIGH      High Priority Mode (Will screw up internet downloads in win95)\n");
        printf(" /NOSTEREO  Do not use Stereo Mode even if its available\n");
        exit(1);
        }
    }
  }

///////////////Initialize Allegro
buffer = create_bitmap(512, 256);
the_image = load_bitmap("SnailMix.BMP", the_pallete);
if (!the_image)
  {
  printf("Error reading bitmap file SnailMix.BMP\n");
  readkey();
  }
allegro_init();

////////////////Initialize SoundCard
if	(InitMixer(0,5,1,dostereo,0)==Success) // pass sb as 0 to get from enviro string
  {
  printf("SB Initialized at IO=%xh IRQ=%d DMA=%d\n",SBIOAddr,SBIRQ,SBDMA);
  printf("SBDsp Ver = %d.%d%d\n",(DSPVer & 0xff00) >> 8,(DSPVer & 0x00f0) >> 4,(DSPVer & 0x000f));
  } else
    {
    printf("Error Initializing the SB.  Try setting BLASTER environment string\n");
    printf("Set Blaster=Axxx Ix Dx\n");
    printf("Ex. : C:\\>Set Blaster=A220 I5 D1\n");
    exit(0);
    }
//////////////////Try to load the song from the command line parameter
if (!LoadS3M(filelist))
  {
  printf("Bad or missing S3M file \"%s\" \n",filelist);
  readkey();
  }

VOC1=LoadVoc("bigdrum.voc"); // Press 1 to play
VOC2=LoadVoc("firing.voc"); // Press 1 to play

printf("%d %d\n",VOC1,VOC2);

set_gfx_mode(GFX_AUTODETECT, 640, 480, 0, 0);
 /* select the bitmap pallete */
 set_pallete(the_pallete);
 /* blit the image onto the screen */
 blit(the_image, screen, 0, 0, (SCREEN_W-the_image->w)/2,
     (SCREEN_H-the_image->h)/2, the_image->w, the_image->h);

PlaySong();
while (!leave)
  {
  if (!HighPriority) PollMixing();
  switch (View)
    {
    case ViewOsc : {
                   clear(buffer);
                   switch (CurBlockNum)
                     {
                     case 1 : if (SBStereo)
                                {
                                for (x=0;x<=512;x++)
                                  {
                                  putpixel(buffer,x>>1,MixBuff[x<<1],255);
                                  }
                                for (x=0;x<=512;x++)
                                  {
                                  putpixel(buffer,(x>>1)+256,MixBuff[(x<<1)+1],255);
                                  }
                                }
                               else
                                {
                                for (x=0;x<=1024;x++)
                                  {
                                  putpixel(buffer,x>>1,MixBuff[x],255);
                                  }

                                } break;
                     case 2 : if (SBStereo)
                                {
                                for (x=0;x<=512;x++)
                                  {
                                  putpixel(buffer,x>>1,MixBuff[x<<1],255);
                                  }
                                for (x=0;x<=512;x++)
                                  {
                                  putpixel(buffer,(x>>1)+256,MixBuff[(x<<1)+1],255);
                                  }
                                }
                               else
                                {
                                for (x=0;x<=1024;x++)
                                  {
                                  putpixel(buffer,x>>1,MixBuff[x+1024],255);
                                  }
                                } break;
                      }
                    blit(buffer, screen, 0, 0, (SCREEN_W-buffer->w)/2,(SCREEN_H-buffer->h)/2, buffer->w, buffer->h);

                   } break;
    case ViewInf :if (flag)
                   {
                   flag=0;

                   sprintf(tmpstr,"Order %d/%d  Pattern %d  Row %d  Tempo %d Speed %d GlobVol %d",ordnum,song.ordnum,patnum,rownum,song.Tempo,song.Speed,song.GVolume);
                   dwritexystr(IT_IX,IT_IY,(4<<4)+15,tmpstr);
                   x=strlen(tmpstr);
                   dclear(IT_IX+x,IT_IY,(4<<4)+9,79-x,' ');

                   for (y=1;y<=MaxChannels;y++)
                     {
                     if (MixChannel[y-1].Playing)
                       {
                       sprintf(tmpstr,"%d",y);
                       dwritexystr(IT_C1X,IT_BY1+y,IT_InsPC,tmpstr);
                       dwritexystr(IT_C2X,IT_BY1+y,IT_INC,DigINS[MixChannel[y-1].SMPIndex].SMPName);
                       x=strlen(DigINS[MixChannel[y-1].SMPIndex].SMPName);
                       dclear(IT_C2X+x,IT_BY1+y,IT_INC,28-x,' ');

                       temp=MixChannel[y-1].RealVol>>3;// div by 8
                       if (temp>1)
                         {
                         for (x=0;x<(temp>>1);x++)
                           dwritexy(IT_C3X+x,IT_BY1+y,14,'');

                         if ((temp&1)==1) // if bit 1 is on it is an odd number
                           dwritexy(IT_C3X+(x++),IT_BY1+y,14,'');
                         if (x<4)
                           dclear(IT_C3X+x,IT_BY1+y,14,4-x,' ');
                         }
                        else
                         {
                         dclear(IT_C3X,IT_BY1+y,14,4,' ');
                         if (temp) dwritexy(IT_C3X,IT_BY1+y,14,'');
                         } // Show the volume for each channel

                       if (MixChannel[y].Effect)
                         dwritexy(IT_C4X,IT_BY1+y,15,MixChannel[y-1].Effect+0x40);
                        else
                         dwritexy(IT_C4X,IT_BY1+y,15,' ');

                       sprintf(tmpstr,"%d/%d",MixChannel[y-1].Vol,MixChannel[y-1].RealVol);
                       dwritexystr(IT_C5X,IT_BY1+y,IT_InsNPC,tmpstr);

                       sprintf(tmpstr,"%d %d/%d ",MixChannel[y-1].PanPos,MixChannel[y-1].LVol,MixChannel[y-1].RVol);
                       dwritexystr(IT_C6X,IT_BY1+y,IT_InsNPC,tmpstr);

                       }
                      else
                       {
                       sprintf(tmpstr,"%d",y);
                       dwritexystr(IT_C1X,IT_BY1+y,IT_InsNPC,tmpstr);
                       dclear(IT_C3X,IT_BY1+y,14,4,' ');
                       } // end if

                     } // end for
                   } break;
    }
  if (kbhit())
    {
    switch (getch())
      {
      case 0 : switch (getch())
                 {
                 case 59 : if (View!=ViewBMP)
                             {
                             if (View!=ViewOsc) set_gfx_mode(GFX_AUTODETECT, 640, 480, 0, 0);
                             set_pallete(the_pallete);
                             blit(the_image, screen, 0, 0, (SCREEN_W-the_image->w)/2,(SCREEN_H-the_image->h)/2, the_image->w, the_image->h);
                             View=ViewBMP;
                             }
                           break;
                 case 60 : if (View!=ViewOsc)
                             {
                             if (View!=ViewBMP) set_gfx_mode(GFX_AUTODETECT, OscWidth, OscHeight, 0, 0);
                             set_pallete(the_pallete);
                             blit(the_image, screen, 0, 0, (SCREEN_W-the_image->w)/2,(SCREEN_H-the_image->h)/2, the_image->w, the_image->h);
                             View=ViewOsc;
                             }
                           break;
                 case 61 : if (View!=ViewInf)
                             {
                             set_gfx_mode(GFX_TEXT, 80, 50, 0, 0);
                             InitInfoScreen();
                             View=ViewInf;
                             }
                           break;
                 case 63 : if (!playing) PlaySong(); break; // F5
                 case 66 : if (playing)
                             {
                             StopSong();
                             for (x=0;x<MaxChannels;x++)
                               StopChannel(x);
                             }break;  // F8

                 case 68 : { // F10
                           disable();
                           switch (CurBlockNum)
                             {
                             case 1 : {
                                      MixBufPos=0;
                                      CurBlockNum=2;
                                      } break;
                             case 2 : {
                                      MixBufPos=MixBlockSize;
                                      CurBlockNum=1;
                                      }
                             }
                           enable();
                           } break;
                 } break;
      case '1' :
                StartSound(VOC1,-1,63,0x40);
                break;
      case '2' :
                StartSound(VOC2,-1,63,0x40);
                break;

      case 18 : if (View!=ViewLoadS3M)
                  {
                  PickS3M();
                  InitBMP();
                  } break;
      case 4 : {
               set_gfx_mode(GFX_TEXT, 50, 80, 0, 0);
               spawnl(P_WAIT, getenv("COMSPEC"), getenv("COMSPEC"), NULL);
               InitBMP();
               } break;

      case 27 : leave=1;break;
/*      case '1' : { StartSound(0,-1,vol,note);} break;
      case '2' : { StartSound(1,-1,vol,note);} break;
      case '3' : { StartSound(2,-1,vol,note);} break;
      case '4' : { StartSound(3,-1,vol,note);} break;
      case '5' : { StartSound(4,-1,vol,note);} break;
      case '6' : { StartSound(5,-1,vol,note);} break;
      case '7' : { StartSound(6,-1,vol,note);} break;
      case '8' : { StartSound(7,-1,vol,note);} break;
      case '9' : { StartSound(8,-1,vol,note);} break;
      case '0' : { StartSound(9,-1,vol,note);} break;*/

/*      case 'b' : {
                 for (index=0;index<256;index++)
                   MixBuff[index]=128;
                 printf("Begining of mixbuffer set to 128\n");
                 } break;
      case 'e' : {
                 for (index=MixBuffSize-256;index<MixBuffSize;index++)
                   MixBuff[index]=128;
                 printf("End of mixbuffer set to 128\n");
                 } break;*/
/*      case ',' : { vol--;} break;
      case '.' : { vol++;} break;

      case ']' : { note++;} break;
      case '[' : { note--;} break;*/
      case '+' : disable(); ChangeOrder(++ordnum); enable(); break;
      case '-' : disable(); ChangeOrder(--ordnum); enable(); break;
/*      case 's' : {
                 StopChannel(-1);
                 }break;*/
      }
    }

  }

KillMixer();

 /* destroy the bitmap */
 destroy_bitmap(the_image);
textbackground(0);
set_gfx_mode(GFX_TEXT, 50, 80, 0, 0);

printf("Snail Mix V1.0 \n");
printf("S3M Mixing and S3M Playing written by %c%c%c %c. %c%c%c%c%c%c",lt1,li1,lm1,lc1,lh1,la1,lr1,lp1,le1,lr1);
}
